unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, DBGrids, DB, Provider, DBClient, ADODB,
  ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    ADOConnection1: TADOConnection;
    ADOQuery1: TADOQuery;
    ClientDataSet1: TClientDataSet;
    DataSetProvider1: TDataSetProvider;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel1: TPanel;
    DBGrid2: TDBGrid;
    Button1: TButton;
    DataSource2: TDataSource;
    ClientDataSet2: TClientDataSet;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
   try
      if (ClientDataSet1.ChangeCount>0) then
      begin
         ClientDataSet2.Data:=ClientDataSet1.Delta;
         ClientDataSet2.Active:=true;
      end;   
   except
   end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   ClientDataSet1.CancelUpdates;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  aUS : TUpdateStatus;
begin
  aUS := ClientDataset2.UpdateStatus;
   case aUS of
    usUnmodified : showmessage('none');
    usModified   : showmessage('update');
    usInserted	 : showmessage('insert');
    usDeleted	 : showmessage('del');
  end;
end;

end.
